diff -Naurb swsusp98/include/linux/suspend-common.h swsusp98+/include/linux/suspend-common.h
--- swsusp98/include/linux/suspend-common.h	2004-07-20 23:01:50.459537781 +0200
+++ swsusp98+/include/linux/suspend-common.h	2004-07-20 23:06:49.382340794 +0200
@@ -8,6 +8,7 @@
 #ifndef SWSUSP_COMMON_H
 #define SWSUSP_COMMON_H
 
+#include <linux/config.h>
 #include <linux/version.h>
 #include <linux/mm.h>
 #include <linux/suspend.h>
diff -Naurb swsusp98/kernel/power/Kconfig swsusp98+/kernel/power/Kconfig
--- swsusp98/kernel/power/Kconfig	2004-07-20 23:01:50.553517027 +0200
+++ swsusp98+/kernel/power/Kconfig	2004-07-20 23:06:49.409334802 +0200
@@ -132,6 +132,15 @@
 		
 			  For normal usage, this option can be turned off.
 
+		config SOFTWARE_SUSPEND_ACPI
+			bool '   Use ACPI S4 support'
+			---help---
+			  This option enables calls to the ACPI code that handles entering
+			  the S4 (suspend-to-disk) state. Since some BIOSes have broken S4
+			  implementations, you might prefer to turn this off. On the other
+			  hand, ACPI wake events may fail to turn the computer back on if
+			  this option is disabled.
+
 		config SOFTWARE_SUSPEND_VARIATION_ANALYSIS
 			bool '   Variation Analysis'
 			---help---
diff -Naurb swsusp98/kernel/power/suspend2.c swsusp98+/kernel/power/suspend2.c
--- swsusp98/kernel/power/suspend2.c	2004-07-20 23:01:50.493530274 +0200
+++ swsusp98+/kernel/power/suspend2.c	2004-07-20 23:06:49.312356328 +0200
@@ -522,6 +522,8 @@
 #if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
 	device_flush_retain_state();
 	drivers_suspend();
+
+#ifdef CONFIG_SOFTWARE_SUSPEND_ACPI
 
 	if (pm_ops && pm_ops->prepare) {
 		if (!pm_ops->prepare(PM_SUSPEND_DISK)) {
@@ -530,6 +531,7 @@
 		}
 	}
 #endif
+#endif
 
 	sys_reboot(LINUX_REBOOT_MAGIC1, LINUX_REBOOT_MAGIC2,
 			LINUX_REBOOT_CMD_POWER_OFF, NULL);
@@ -602,7 +604,7 @@
 
 	spin_unlock_irqrestore(&suspend_irq_lock, suspendirqflags);
 
-#if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
+#ifdef CONFIG_SOFTWARE_SUSPEND_ACPI
 	if (pm_ops && pm_ops->finish)
 		pm_ops->finish(PM_SUSPEND_DISK);
 #endif
